/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package eb;
import java.rmi.*;
import javax.ejb.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */
public class AccountBean implements EntityBean {
  EntityContext entityContext;
  public int    number;
  public String customer;
  public long   balance;

  public AccountBeanPK ejbCreate(int number, String customer, long balance)
          throws CreateException, RemoteException {
    this.number = number;
    this.customer = customer;
    this.balance = balance;
    return null;
  }

  public AccountBeanPK ejbCreate(int number)
          throws RemoteException, CreateException, RemoteException {
    return ejbCreate(number, null, 0);
  }

  public void ejbPostCreate(int number, String customer, long balance)
          throws CreateException, RemoteException {}

  public void ejbPostCreate(int number)
          throws CreateException, RemoteException {
    ejbPostCreate(number, null, 0);
  }

  public void ejbLoad() throws RemoteException {}

  public void ejbStore() throws RemoteException {}

  public void ejbRemove() throws RemoveException, RemoteException {}

  public void ejbActivate() throws RemoteException {}

  public void ejbPassivate() throws RemoteException {}

  public void setEntityContext(EntityContext entityContext)
          throws RemoteException {
    this.entityContext = entityContext;
  }

  public void unsetEntityContext() throws RemoteException {
    entityContext = null;
  }

  public int getNumber() {
    return number;
  }

  public String getCustomer() {
    return customer;
  }

  public void setCustomer(String customer) {
    this.customer = customer;
  }

  public long getBalance() {
    return balance;
  }

  // not generated
  public void deposit(long d) throws AccountException {
    if (d < 0) {
      throw new AccountException("Sorry '" + getCustomer()
                                 + "', you cannot deposit negative amounts ("
                                 + d + ")!");
    }
    balance = balance + d;
  }

  // not generated
  public void withdraw(long d) throws AccountException {
    if (d < 0) {
      throw new AccountException("Sorry '" + getCustomer()
                                 + "', you cannot withdraw negative amounts ("
                                 + d + ")!");
    }
    long original = balance;

    balance = balance - d;
    if (balance < 0) {
      throw new AccountException("Sorry '" + getCustomer()
                                 + "', you cannot withdraw (" + d
                                 + ") more than you have in your account ("
                                 + original + ")");
    }
  }

  // not generated
  public String printCustomer() {
    return "'" + getCustomer() + "'";
  }

}
